#include <windows.h>
#include <windowsx.h>
#include <winsock.h>
#include <richedit.h>
#include <commdlg.h>
#include <stdio.h>
#include "trayicon.h"
#include "resource.h"
#define WM_TRAY   WM_USER+0x100+5
BOOL FindandSetDll(char *DLLName);
void GetNewTextColor(HWND WinPass);
void CreateDefaultSettings();
void LoadFileText();
void SetAlignment(WORD wAlignment);
void SetTextEffect(WORD wEffect);
void SaveFileText();
static VOID ChangeFont(HWND hWnd);
WINDOWPOS* wp;
int GetColorSetting(int ColorNum), IsShade =0;
DWORD CALLBACK EditStreamCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb);
LRESULT CALLBACK WndProc( HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam);
BOOL CALLBACK AboutProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow);
static char g_szClassName[] = "Adam Foster Pad 4.0";
static char UserIniFile[] = ".\\afpad4.ini";
static HINSTANCE g_hInst;
int IsViewSafe = 0;
CTrayIcon *pTrayIcon;
HWND hwnd,EditText;
HWND hwndWinamp,HttpView,UserUrlGet,AFAbout;
HANDLE isINI,esFile;
HANDLE hCaret;
//Threading
HANDLE HttpHandle;
HANDLE ColorHandle;
DWORD threadID[1];
//DLL
HINSTANCE RichDLL;
//Images
HICON mainIcon;
HANDLE hbm;
//Menus
HMENU MainPop,EditPop,AlignPop,FormatPop,TrayMenu;
CHARFORMAT cf;
EDITSTREAM FAR es;
DWORD dwTextColor;
char *RichType;
char *RichFile;
int RichGo,AppWidth,AppHeight;
char filename[256];
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow)
	{
	GetPrivateProfileString("AFPad", "FileName", "afpad4.afp", filename, 256, UserIniFile);
	AppWidth = GetPrivateProfileInt("AFPad","Width",302,UserIniFile);
	AppHeight = GetPrivateProfileInt("AFPad","Height",162,UserIniFile);
	WNDCLASSEX WndClass;
	MSG Msg;
	g_hInst = hInstance;
	WndClass.cbSize 	   = sizeof(WNDCLASSEX);
	WndClass.style		   = NULL;
	WndClass.lpfnWndProc   = WndProc;
	WndClass.cbClsExtra    = NULL;
	WndClass.cbWndExtra    = NULL;
	WndClass.hInstance	   = g_hInst;
	WndClass.hIcon		   = LoadIcon( g_hInst, MAKEINTRESOURCE(IDI_ICON2));
	WndClass.hCursor	   = NULL;
	WndClass.hbrBackground = NULL;//CreateSolidBrush(GetColorSetting(0));
	WndClass.lpszMenuName  = NULL;
	WndClass.lpszClassName = g_szClassName;
	WndClass.hIconSm	   = NULL;	
	if(!RegisterClassEx(&WndClass))
		{
		MessageBox(0,"Window Registration Failed!","Error!",
			MB_ICONEXCLAMATION|MB_OK|MB_SYSTEMMODAL);
		return 0;
		}
	hwnd = CreateWindowEx(WS_EX_TOOLWINDOW|WS_EX_ACCEPTFILES,//|WS_EX_LAYERED
		g_szClassName,"AFPad",WS_POPUP,
		0,0,AppWidth,AppHeight,NULL,NULL,g_hInst,NULL);
	if(hwnd == NULL)
		{
		MessageBox(0,"Window Creation Failed!","Error!",
			MB_ICONEXCLAMATION|MB_OK|MB_SYSTEMMODAL);
		return 0;
		}
	//Windows 2000 Alpha Layered Window Attribute
	//int mrtc_color = RGB(0,0,0);
	//SetLayeredWindowAttributes(hwnd,(COLORREF)mrtc_color,200,LWA_ALPHA);
	if(FindandSetDll("Riched20.dll")==TRUE)
		{
		RichGo = 1;
		}
	else
		if(FindandSetDll("Riched32.dll")==TRUE)
			{
			RichGo = 1;
			}
		if (RichGo == 1)
			{
			RichDLL = LoadLibrary(RichFile);
			EditText = CreateWindowEx(WS_EX_TRANSPARENT|WS_EX_LEFTSCROLLBAR,RichType,NULL,
				WS_CHILD|WS_VISIBLE|ES_WANTRETURN|ES_AUTOVSCROLL|ES_NOHIDESEL|ES_MULTILINE|WS_VSCROLL,
				0,15,AppWidth,AppHeight - 15,hwnd,NULL,g_hInst,NULL);
			cf.cbSize = sizeof(CHARFORMAT);
			cf.dwMask = CFM_COLOR;
			cf.crTextColor = (COLORREF)GetColorSetting(2);
			SendMessage(EditText, EM_SETCHARFORMAT, SCF_ALL,(LPARAM)&cf);
			//SendMessage(EditText, EM_AUTOURLDETECT, TRUE,0);
			SendMessage(EditText, EM_SETBKGNDCOLOR, 0, (LPARAM)(COLORREF)GetColorSetting(3));
			CHARFORMAT cfDefault;
			cfDefault.cbSize = sizeof(cfDefault);
			cfDefault.dwEffects = CFE_PROTECTED; 
			cfDefault.dwMask = CFM_BOLD|CFM_FACE|CFM_SIZE|CFM_CHARSET|CFM_PROTECTED;
			cfDefault.yHeight = 200;
			cfDefault.bCharSet = 0xEE;
			cfDefault.bPitchAndFamily = FIXED_PITCH|FF_MODERN;
			strcpy(cfDefault.szFaceName, "Courier New"); 
			SendMessage(EditText,EM_SETCHARFORMAT,SCF_ALL,(LPARAM)&cfDefault);
			es.dwCookie = 0;
			SendMessage(EditText, EM_STREAMIN, SF_RTF|SFF_PLAINRTF|SFF_SELECTION, (LPARAM)&es);
			SendMessage(EditText, EM_CANUNDO, 0 ,0);
			SendMessage(EditText, EM_CANREDO, 0, 0);
			SendMessage(EditText, EM_CANPASTE,0,0);
			SendMessage(EditText, EM_SETUNDOLIMIT, (WPARAM)5,0);
			SendMessage(EditText, EM_SETTEXTMODE, TM_RICHTEXT | TM_MULTILEVELUNDO, 0);
			DragAcceptFiles (EditText, TRUE);
			SendMessage(EditText, EM_SETEVENTMASK, 0,(LPARAM)ENM_DROPFILES);
			//SendMessage(EditText,EM_FMTLINES,FALSE,0);
			}
		else
			{
			MessageBox(0,"The file Riched20.dll was not found.\nPlease load http://www.microsoft.com to find this dll.\nNow going to try and load Riched32.dll.","Error!",
				MB_ICONEXCLAMATION|MB_OK|MB_SYSTEMMODAL);
			exit(0);
			}
		ShowWindow(hwnd,SW_SHOWNA);
		UpdateWindow(hwnd);
		SendMessage(EditText,EM_SETSEL,(WPARAM)(INT)0,(LPARAM)(INT)1);
		SendMessage(EditText,EM_SCROLLCARET,0,0);
		SendMessage(EditText,EM_SETSEL,(WPARAM)(INT)0,(LPARAM)(INT)0);
		while(GetMessage(&Msg,NULL,0,0))
			{
			TranslateMessage(&Msg);
			DispatchMessage(&Msg);
			}
		return Msg.wParam;
	}
int GetColorSetting(int ColorNum)
	{
	int apc_red,apc_green,apc_blue,apc_color;
	int atc_red,atc_green,atc_blue,atc_color;
	int rtc_red,rtc_green,rtc_blue,rtc_color;
	int rtb_red,rtb_green,rtb_blue,rtb_color;
	switch(ColorNum)
		{
		case 0:
			{
			apc_red = GetPrivateProfileInt("App Color", "Red", 130, UserIniFile);
			apc_green = GetPrivateProfileInt("App Color", "Green", 160,UserIniFile);
			apc_blue = GetPrivateProfileInt("App Color", "Blue", 50, UserIniFile);
			apc_color = RGB(apc_red,apc_green,apc_blue);
			return apc_color;
			}
			break;
		case 1:
			{
			atc_red = GetPrivateProfileInt("Title Color", "Red",255, UserIniFile);
			atc_green = GetPrivateProfileInt("Title Color", "Green",255, UserIniFile);
			atc_blue = GetPrivateProfileInt("Title Color", "Blue",255, UserIniFile);
			atc_color = RGB(atc_red,atc_green,atc_blue);
			return atc_color;
			}
			break;
		case 2:
			{
			rtc_red = GetPrivateProfileInt("Text Color","Red",240,UserIniFile);
			rtc_green = GetPrivateProfileInt("Text Color","Green",208,UserIniFile);
			rtc_blue = GetPrivateProfileInt("Text Color","Blue",48,UserIniFile);
			rtc_color = RGB(rtc_red,rtc_green,rtc_blue);
			return rtc_color;
			}
			break;
		case 3:
			{
			rtb_red = GetPrivateProfileInt("Text Back","Red", 0, UserIniFile);
			rtb_green = GetPrivateProfileInt("Text Back", "Green", 0, UserIniFile);
			rtb_blue = GetPrivateProfileInt("Text Back", "Blue", 0, UserIniFile);
			rtb_color = RGB(rtb_red, rtb_green, rtb_blue);
			return rtb_color;
			}
			break;
		}
	return 0;
	}
void CreateDefaultSettings()
	{
	WritePrivateProfileString("AFPad","TitleName","Adam Foster Pad 4!",UserIniFile);
	WritePrivateProfileString("AFPad","FileName","afpad4.afp",UserIniFile);
	WritePrivateProfileString("AFPad","Width","302",UserIniFile);
	WritePrivateProfileString("AFPad","Height","162",UserIniFile);
	WritePrivateProfileString("Title Color","Red","0",UserIniFile);
	WritePrivateProfileString("Title Color","Green","0",UserIniFile);
	WritePrivateProfileString("Title Color","Blue","0",UserIniFile);
	WritePrivateProfileString("App Color","Red","192",UserIniFile);
	WritePrivateProfileString("App Color","Green","80",UserIniFile);
	WritePrivateProfileString("App Color","Blue","91",UserIniFile);
	WritePrivateProfileString("Text Color","Red","240",UserIniFile);
	WritePrivateProfileString("Text Color","Green","208",UserIniFile);
	WritePrivateProfileString("Text Color","Blue","48",UserIniFile);
	WritePrivateProfileString("Text Back","Red","0",UserIniFile);
	WritePrivateProfileString("Text Back","Green","0",UserIniFile);
	WritePrivateProfileString("Text Back","Blue","0",UserIniFile);
	WritePrivateProfileString("Docking","Move","1",UserIniFile);
	WritePrivateProfileString("Docking","Left","0",UserIniFile);
	WritePrivateProfileString("Docking","Top","0",UserIniFile);
	}
BOOL FindandSetDll(char* DLLName)
	{
	TCHAR  szPathname[MAX_PATH];
	LPTSTR lpszFilename;
	if(SearchPath(NULL,DLLName,NULL,MAX_PATH,szPathname,&lpszFilename))
		{
		if(DLLName == "Riched20.dll")
			{
			RichType = "RICHEDIT20A";
			RichFile = DLLName;
			return TRUE;
			}
		else if(DLLName == "Riched32.dll")
			{
			RichType = "RICHEDIT";
			RichFile = DLLName;
			return TRUE;
			}
		}
	return FALSE;
	}
void LoadFileText()
	{
	es.dwCookie = 0;
	SendMessage(EditText, EM_STREAMIN, SF_RTF, (LPARAM)&es);
	}
void SaveFileText()
	{
	es.dwCookie = 1;
	SendMessage(EditText, EM_STREAMOUT, SF_RTF, (LPARAM)&es);
	}
void GetNewTextColor(HWND WinPass)
	{
	CHOOSECOLOR cc;
	DWORD dwColors[ 16 ];
	memset( &cc, 0, sizeof(CHOOSECOLOR) );
	cc.lStructSize = sizeof(CHOOSECOLOR);
	cc.hwndOwner = WinPass;;
	cc.lpCustColors = dwColors;
	cc.Flags = CC_RGBINIT | CC_FULLOPEN;
	cc.rgbResult = dwTextColor;
	ChooseColor( &cc );
	dwTextColor = cc.rgbResult;
	memset( &cf, 0, sizeof(CHARFORMAT) );
	cf.cbSize = sizeof(CHARFORMAT);
	cf.dwMask = CFM_COLOR;
	cf.crTextColor = dwTextColor;
	SendMessage(EditText, EM_SETCHARFORMAT, SCF_SELECTION,(LPARAM)&cf);
	BringWindowToTop(hwnd);
	}
void SetAlignment(WORD wAlignment)
	{
	PARAFORMAT pf;
	pf.cbSize = sizeof(PARAFORMAT);
	SendMessage(EditText, EM_GETPARAFORMAT, 0, (LPARAM) &pf);
	if(!(pf.dwMask & PFM_ALIGNMENT) || pf.wAlignment != wAlignment)
		{
		pf.dwMask = PFM_ALIGNMENT;
		pf.wAlignment = wAlignment;
		SendMessage(EditText, EM_SETPARAFORMAT, 0, (LPARAM) &pf);
		}
	}
void SetTextEffect(WORD wEffect)
	{
	cf.dwMask = wEffect;
	SendMessage(EditText, EM_GETCHARFORMAT, TRUE, (LPARAM)&cf);
	cf.dwEffects ^= wEffect;
	SendMessage(EditText, EM_SETCHARFORMAT, SCF_SELECTION|SCF_WORD,(LPARAM)&cf);
	}
DWORD CALLBACK EditStreamCallback(DWORD dwCookie, LPBYTE pbBuff, LONG cb, LONG *pcb)
	{
	esFile = CreateFile(filename, GENERIC_READ | GENERIC_WRITE, 0, NULL,OPEN_ALWAYS,
		FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN, NULL);
	if (dwCookie == 0)
		{
		*pcb = 0;
		ReadFile(esFile, pbBuff, cb, (unsigned long*)pcb, 0);
		}
	else
		{
		WriteFile(esFile, pbBuff, cb, (unsigned long*)pcb, 0);
		}
	CloseHandle(esFile);
	return 0;
	}
static VOID ChangeFont(HWND hWnd)
	{
	CHARFORMAT cf;
	CHOOSEFONT chFont;
	LOGFONT    lf;
	HDC        hDC;	
	cf.cbSize = sizeof(CHARFORMAT);
	SendMessage(EditText,EM_GETCHARFORMAT,TRUE,(LPARAM)&cf);
	ZeroMemory(&chFont,sizeof(CHOOSEFONT));
	ZeroMemory(&lf,sizeof(LOGFONT));
	hDC = GetDC(hwnd);
	lf.lfHeight = MulDiv(cf.yHeight,
		GetDeviceCaps(hDC,LOGPIXELSY),-1440);
	ReleaseDC(hwnd,hDC);
	lf.lfWeight = (cf.dwEffects & CFE_BOLD) ? FW_BOLD : FW_NORMAL;
	lf.lfItalic = (BOOL)(cf.dwEffects & CFE_ITALIC);
	lf.lfStrikeOut = (BOOL)(cf.dwEffects & CFE_STRIKEOUT);
	lf.lfUnderline = (BOOL)(cf.dwEffects & CFE_UNDERLINE);
	lf.lfCharSet = cf.bCharSet;  // ANSI_CHARSET;
	lf.lfQuality = DEFAULT_QUALITY;
	lf.lfPitchAndFamily = cf.bPitchAndFamily;
	strcpy(lf.lfFaceName,cf.szFaceName);
	chFont.lStructSize = sizeof(CHOOSEFONT);
	chFont.hwndOwner   = hWnd;
	chFont.lpLogFont   = &lf;
	chFont.Flags       = CF_SCREENFONTS|CF_SCALABLEONLY|
		CF_EFFECTS|CF_INITTOLOGFONTSTRUCT;
	if (!(cf.dwEffects & CFE_AUTOCOLOR))
		chFont.rgbColors = cf.crTextColor;
	if (ChooseFont(&chFont))
		{
		cf.dwMask = CFM_BOLD | CFM_FACE | CFM_ITALIC |
			CFM_CHARSET | CFM_OFFSET | CFM_SIZE |
			CFM_STRIKEOUT | CFM_UNDERLINE;
		cf.yHeight = 2 * chFont.iPointSize;
		cf.yOffset = 0;
		cf.dwEffects = 0;
		if (lf.lfWeight >= FW_BOLD) cf.dwEffects |= CFE_BOLD;
		if (lf.lfItalic)            cf.dwEffects |= CFE_ITALIC;
		if (lf.lfStrikeOut)         cf.dwEffects |= CFE_STRIKEOUT;
		if (lf.lfUnderline)         cf.dwEffects |= CFE_UNDERLINE;
		cf.bCharSet = lf.lfCharSet;
		cf.bPitchAndFamily = lf.lfPitchAndFamily;
		if (chFont.rgbColors == GetSysColor(COLOR_WINDOWTEXT))
			cf.dwEffects |= CFE_AUTOCOLOR;
		else
			cf.crTextColor = chFont.rgbColors;
		strcpy(cf.szFaceName,lf.lfFaceName);
		SendMessage(EditText,EM_SETCHARFORMAT,SCF_SELECTION,(LPARAM)&cf);
		}
	}
LRESULT CALLBACK WndProc( HWND hwnd, UINT Message, WPARAM wParam, LPARAM lParam)
	{
	int dockX,dockY;
	int oldX,oldY;
	int oldBottom,oldRight;
	int Width,Height;
	es.pfnCallback = EditStreamCallback;
	cf.cbSize = sizeof(CHARFORMAT);
	int move;
	RECT oldRect;
	GetWindowRect(hwnd,&oldRect);
	oldX = oldRect.left;
	oldY = oldRect.top;
	oldRight = oldRect.right;
	oldBottom = oldRect.bottom;
	Width = oldRight - oldX;
	Height = oldBottom - oldY;
	POINT pts;
	move = GetPrivateProfileInt("Docking","Move",1,UserIniFile);
	dockX = GetPrivateProfileInt("Docking","Left",0,UserIniFile);
	dockY = GetPrivateProfileInt("Docking","Top",0,UserIniFile);
	switch(Message)
		{
		case WM_CONTEXTMENU:
			{
			EditPop = CreatePopupMenu();
			AlignPop = CreatePopupMenu();
			FormatPop = CreatePopupMenu();
			AppendMenu(AlignPop, MF_ENABLED | MF_STRING,206,"Left");
			AppendMenu(AlignPop, MF_ENABLED | MF_STRING,207,"Center");
			AppendMenu(AlignPop, MF_ENABLED | MF_STRING,208,"Right");
			AppendMenu(FormatPop, MF_ENABLED | MF_STRING,201,"Bold");
			AppendMenu(FormatPop, MF_ENABLED | MF_STRING,202,"Italic");
			AppendMenu(FormatPop, MF_ENABLED | MF_STRING,203,"Underline");
			AppendMenu(FormatPop, MF_ENABLED | MF_STRING,204,"StrikeOut");
			//AppendMenu(EditPop, MF_ENABLED | MF_STRING | MF_POPUP,(UINT)MainPop, "File");
			AppendMenu(EditPop, MF_ENABLED | MF_STRING | MF_POPUP,(UINT)FormatPop,"Format");
			AppendMenu(EditPop, MF_ENABLED | MF_STRING |MF_POPUP,(UINT)AlignPop,"Alignment");
			//AppendMenu(EditPop, MF_ENABLED | MF_STRING ,209, "Find Text");
			AppendMenu(EditPop, MF_ENABLED | MF_STRING,205,"Pick Color");
			AppendMenu(EditPop, MF_ENABLED | MF_STRING, 211, "Pick Font");
			pts.x =LOWORD(lParam);
			pts.y = HIWORD(lParam);
			TrackPopupMenu(EditPop,TPM_CENTERALIGN|TPM_VCENTERALIGN|TPM_RIGHTBUTTON,
				pts.x,pts.y,0,hwnd,NULL);
			DestroyMenu(EditPop);
			DestroyMenu(AlignPop);
			DestroyMenu(FormatPop);
			}
			break;
		case WM_ACTIVATE:
			{
			}
			break;
		case WM_NCRBUTTONDOWN:
			{
			MainPop = CreatePopupMenu();
			AppendMenu(MainPop, MF_ENABLED | MF_STRING, 100, "&Edit Settings");
			AppendMenu(MainPop, MF_ENABLED | MF_STRING, 101, "&Make Default Settings");
			AppendMenu(MainPop, MF_ENABLED | MF_STRING, 102, "&Web Site");
			AppendMenu(MainPop, MF_ENABLED | MF_STRING, 103, "&About AFPad 4");
			AppendMenu(MainPop, MF_ENABLED | MF_STRING, 105, "Clear");
			AppendMenu(MainPop, MF_ENABLED | MF_STRING, 106, "Exit");
			DWORD dw = GetMessagePos();
			TrackPopupMenu(MainPop, TPM_RIGHTALIGN | TPM_LEFTBUTTON, LOWORD(dw), HIWORD(dw), 0, hwnd, NULL);
			DestroyMenu(MainPop);
			return 0;
			}
		case WM_NCHITTEST:
			{
			int CliClick;
			move = GetPrivateProfileInt("Docking","Move",1,UserIniFile);
			if(move == 1)
				{
				CliClick = DefWindowProc(hwnd, Message, wParam, lParam);
				return CliClick == HTCLIENT ? HTCAPTION : CliClick;
				}
			}
			break;
		case WM_PAINT:
			{
			//Setup painting
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hwnd,&ps);
			HDC hdcMem = CreateCompatibleDC(NULL);
			HBITMAP hbmT = SelectBitmap(hdcMem,hbm);
			BITMAP bm;
			HDC buf = CreateCompatibleDC(NULL);
			HBITMAP bufbmp = CreateCompatibleBitmap(hdc, AppWidth, AppHeight);
			HBITMAP oldbufbmp = NULL;
			GetObject(hbm,sizeof(bm),&bm);
			oldbufbmp = (HBITMAP)SelectObject(buf, bufbmp);
			StretchBlt(buf,0,0,AppWidth,AppHeight,hdcMem,0,0,bm.bmWidth,bm.bmHeight,SRCCOPY);
			SelectBitmap(hdcMem,hbmT);
			//Start -- Stuff for the Title
			SetBkMode(buf, TRANSPARENT);
			SetTextColor(buf, GetColorSetting(1));
			SetTextAlign(buf, TA_LEFT|TA_TOP);
			RECT tirec;
			tirec.top = 0;
			tirec.left = 0;
			tirec.right = AppWidth -1;
			tirec.bottom = 15;
			char titleName[200];
			GetPrivateProfileString("AFPad", "TitleName", "Adam Foster Pad 3", titleName, 200, UserIniFile);
			DrawText(buf,titleName, strlen(titleName),&tirec,DT_TOP|DT_LEFT);
			//End -- Stuff for the Title
			BitBlt(hdc, 0, 0, AppWidth, AppHeight, buf, 0, 0, SRCCOPY);
			SelectObject(buf, oldbufbmp);
			DeleteObject(bufbmp);
			DeleteDC(buf);
			DeleteDC(hdcMem);
			DeleteObject(oldbufbmp);
			EndPaint(hwnd, &ps);
			}
			break;
		case WM_CREATE:
			{
			hbm = LoadImage(g_hInst,"back.bmp",IMAGE_BITMAP,0,0,LR_LOADFROMFILE);
			mainIcon = LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON2));
			pTrayIcon = new CTrayIcon(hwnd, WM_TRAY, NULL, mainIcon, "AFPad 3");
			pTrayIcon->Put();
			switch(move)
				{
				case 0:
					{
					SetWindowPos(hwnd,HWND_BOTTOM,dockX,dockY,Width,Height,SWP_NOMOVE);
					}
					break;
				default:
					{
					SetWindowPos(hwnd,HWND_NOTOPMOST,dockX,dockY,Width,Height,SWP_SHOWWINDOW);
					}
				}
			}
			break;
		case WM_COMMAND:
			{
			switch (wParam)
				{
				case 100:
					{
					ShellExecute(NULL,NULL,UserIniFile,NULL,NULL,SW_SHOWMAXIMIZED);
					}
					break;
				case 101:
					{
					CreateDefaultSettings();
					}
					break;
				case 102:
					{
					ShellExecute(NULL,NULL,"http://www.nasiry.cc",NULL,NULL,SW_SHOWNORMAL);
					}
					break;
				case 103:
					{
					AFAbout = CreateDialog(g_hInst, MAKEINTRESOURCE(IDD_ABOUT), hwnd, AboutProc);
					}
					break;
				case 105:
					{
					SetWindowText(EditText,"");
					}
					break;
				case 106:
					{
					DestroyWindow(hwnd);
					}
					break;
				case 201:
					{
					SetTextEffect(CFM_BOLD);
					}
					break;
				case 202:
					{
					SetTextEffect(CFM_ITALIC);
					}
					break;
				case 203:
					{
					SetTextEffect(CFM_UNDERLINE);
					}
					break;
				case 204:
					{
					SetTextEffect(CFM_STRIKEOUT);
					}
					break;
				case 205:
					{
					ColorHandle = CreateThread(0,0,
						(LPTHREAD_START_ROUTINE)GetNewTextColor,hwnd,0,&threadID[1]);
					}
					break;
				case 206:
					{
					SetAlignment(PFA_LEFT);
					}
					break;
				case 207:
					{
					SetAlignment(PFA_CENTER);
					}
					break;
				case 208:
					{
					SetAlignment(PFA_RIGHT);
					}
					break;
				case 209:
				{/*
				 char *findtext;
				 int index;
				 FINDTEXTEX local_find;
				 local_find.chrg.cpMin = 0; //start position
				 local_find.chrg.cpMax = -1; //tells to include everything
				 local_find.lpstrText = findtext;
				SendMessage(EditText,EM_FINDTEXTEX,FR_WHOLEWORD,(LPARAM) &local_find);*/
				}
				break;
				case 211:
					{
					ChangeFont(hwnd);
					}
					break;
				case 301:
					{
					BringWindowToTop(hwnd);
					}
					break;
				case 302:
					{
					DestroyWindow(hwnd);
					}
					break;
				case 400:
					{
					hwndWinamp = FindWindow("Winamp v1.x",NULL);
					SendMessage(hwndWinamp,WM_COMMAND, 40047, NULL);
					}
					break;
				case 401:
					{
					hwndWinamp = FindWindow("Winamp v1.x",NULL);
					SendMessage(hwndWinamp,WM_COMMAND, 40045, NULL);
					}
					break;
				case 402:
					{
					hwndWinamp = FindWindow("Winamp v1.x",NULL);
					SendMessage(hwndWinamp,WM_COMMAND, 40048, NULL);
					}
					break;
				case 403:
					{
					hwndWinamp = FindWindow("Winamp v1.x",NULL);
					SendMessage(hwndWinamp,WM_COMMAND, 40044, NULL);
					}
					break;
			}
		}
		break;
		case WM_NCLBUTTONDBLCLK:
			{
			switch(IsShade)
				{
				case 0:
					{
					IsShade = 1;
					SetWindowPos(hwnd,HWND_NOTOPMOST,oldRect.left,oldRect.top +(AppHeight-15),AppWidth,15,SWP_SHOWWINDOW);
					}
					break;
				case 1:
					{
					IsShade = 0;
					SetWindowPos(hwnd,HWND_NOTOPMOST,oldRect.left,oldRect.top-(AppHeight +15),AppWidth,AppHeight,SWP_SHOWWINDOW);
					}
					break;
				}
			}
			break;
		case WM_WINDOWPOSCHANGING:
			{
			wp = (WINDOWPOS*)lParam;
			SystemParametersInfo(SPI_GETWORKAREA,NULL,&oldRect,NULL);
			int ScreenX,ScreenY,SnapEdge;
			SnapEdge = 20;
			ScreenX = oldRect.right - oldRect.left;
			ScreenY = oldRect.bottom - oldRect.top;
			if(wp->x < SnapEdge && wp->x > - SnapEdge)
				wp->x = 0;
			if(wp->x + AppWidth > (ScreenX - SnapEdge) && wp->x + AppWidth < ScreenX + SnapEdge)
				wp->x = ScreenX - AppWidth;
			if(wp->y < SnapEdge && wp->y > - SnapEdge)
				wp->y = 0;
			if(wp->y + AppHeight > (ScreenY - SnapEdge) && wp->y + AppHeight < ScreenY + SnapEdge)
				wp->y = ScreenY - AppHeight;
			}
			break;
		case WM_TRAY:
			{
			switch(lParam)
				{
				case WM_RBUTTONDOWN:
					{
					TrayMenu = CreatePopupMenu();
					AppendMenu(TrayMenu, MF_ENABLED | MF_STRING,302,"Exit");
					AppendMenu(TrayMenu, MF_ENABLED | MF_STRING,301,"Show");
					AppendMenu(TrayMenu, MF_DISABLED| MF_STRING, NULL,">>Winamp<<");
					AppendMenu(TrayMenu, MF_ENABLED | MF_STRING, 403,"Previous");
					AppendMenu(TrayMenu, MF_ENABLED | MF_STRING, 400,"Stop");
					AppendMenu(TrayMenu, MF_ENABLED | MF_STRING, 401,"Play");
					AppendMenu(TrayMenu, MF_ENABLED | MF_STRING, 402,"Next");
					POINT pt;
					GetCursorPos(&pt);
					TrackPopupMenu(TrayMenu, TPM_BOTTOMALIGN | TPM_RIGHTALIGN,
						pt.x, pt.y, 0, hwnd, 0);
					}
					break;
				case WM_LBUTTONDBLCLK:
					{
					hwndWinamp = FindWindow("Winamp v1.x",NULL);
					SendMessage(hwndWinamp,WM_COMMAND,40046,NULL);
					SetForegroundWindow(hwnd);
					SendMessage(hwndWinamp,WM_COMMAND,40046,NULL);
					}
					break;
				case WM_LBUTTONDOWN:
					{
					SetForegroundWindow(hwnd);
					}
					break;
				case WM_MBUTTONDOWN:
					{
					hwndWinamp = FindWindow("Winamp v1.x",NULL);
					SendMessage(hwndWinamp,WM_COMMAND, 40048, NULL);
					}
					break;
				}
			}
			break;
		case WM_CLOSE:
			{
			SaveFileText();
			CloseHandle(ColorHandle);
			CloseHandle(hbm);
			DestroyWindow(hwnd);
			FreeLibrary(RichDLL);
			}
			break;
		case WM_DESTROY:
			{
			SaveFileText();
			TerminateThread(ColorHandle,0);
			pTrayIcon->Remove();
			delete pTrayIcon;
			DeleteObject(hbm);
			DestroyIcon((HICON)mainIcon);
			DestroyMenu(TrayMenu);
			PostQuitMessage(0);
			}
			break; 
		default:
			return DefWindowProc(hwnd, Message, wParam, lParam);
	}
	return 0;
}
BOOL CALLBACK AboutProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
	{
	switch(msg)
		{
		case WM_COMMAND:
			{
			switch(LOWORD(wParam))
				{
				case IDOK:
					{
					EndDialog(hwnd,IDOK);
					}
				}
			}
			break;
		}
	return FALSE;
	}