#include <windows.h>
#include <stdio.h>
#include "..\\iconbox.h"

__declspec( dllexport ) HOOKPROC HookFunction(int code, WPARAM wParam, LPARAM lParam);
__declspec( dllexport ) void Quit();

HWND MainWnd;
HHOOK hook=0;

HOOKPROC HookFunction(int code, WPARAM wParam, LPARAM lParam)
{
	//if (code < 0) return (HOOKPROC)CallNextHookEx(hook, code, wParam, lParam);
	switch (code)
	{
		case HCBT_MINMAX:
		{
			if (LOWORD(lParam) == SW_MINIMIZE)
			{
				if (!MainWnd) MainWnd = FindWindowEx(FindWindow("DesktopBackgroundClass", "LSDesktop"), NULL, "LSIconBox", NULL);
				if (!MainWnd) MainWnd = FindWindow("LSIconBox", "LSIconBox");
				SendMessage(MainWnd, IB_MIN, wParam, 0);
			}
		}
		break;

		case HCBT_SYSCOMMAND:
		{
			if (wParam == SC_RESTORE)
			{
				SendMessage(MainWnd, IB_RESTORE, 0, 0);
			}
		}
		return 0;
	}

	return 0;
}

void Quit()
{
}