/***********************************************************
*        Sample - Sample Litestep Module Code              *
* This single source file is the code to sample.           *
*                         *  *  *  *                       *
* Last Update:  September 27, 1999 10:00 PM                *
*                         *  *  *  *                       *
* Copyright (c) 1999 Shaheen Gandhi                        *
***********************************************************/

#include <windows.h>
#include "exports.h"
#include "lsapi.h"

char *szApp = "LSRes";
HWND hWnd = NULL;

void BangChangeResolution(HWND caller, char *args)
{
	char buffer[15] = "";
	int x, y;
	DEVMODE* mode = (DEVMODE*)malloc(sizeof(DEVMODE));
	
	strcpy(buffer, args);
	x = atoi(strtok(buffer, "x"));
	y = atoi(strtok(NULL, ""));
	
	if (x > 0 && y > 0)
	{
		mode->dmSize = sizeof(DEVMODE);
		EnumDisplaySettings(NULL, 0, mode);
		mode->dmPelsWidth = x;
		mode->dmPelsHeight = y;
		mode->dmFields = DM_PELSWIDTH | DM_PELSHEIGHT;
		ChangeDisplaySettings(mode, CDS_UPDATEREGISTRY);
	}
	
	free(mode);
	return;
}

int initModuleEx(HWND parent, HINSTANCE dll, LPCSTR szPath)
{
	AddBangCommand("!CHANGERESOLUTION",BangChangeResolution);	
	return 0;
}

int initModule(HWND parent, HINSTANCE dll, wharfDataType *wd)
{
  return initModuleEx(parent, dll, wd->lsPath);
}

int quitModule(HINSTANCE dll)
{
	RemoveBangCommand("!CHANGERESOLUTION");
 	return 0;
}